#include "Quad.h"
#include "Vertex.h"

Quad::Quad(IDirect3DDevice9* device)
{
	// save a ptr to the device
	_device = device;

	// Create a vertex buffer 
	_device->CreateVertexBuffer(
		6 * sizeof(Vertex), 
		D3DUSAGE_WRITEONLY,
		FVF_VERTEX,
		D3DPOOL_MANAGED,
		&_vb,
		0);

	Vertex* v = NULL;
	_vb->Lock(0, 0, (void**)&v, 0);

	v[0] = Vertex( -1.0f, -1.0f, 1.25f, 0.0f, 0.0f, -1.0f, 0.0f, 1.0f );
	v[1] = Vertex( -1.0f,  1.0f, 1.25f, 0.0f, 0.0f, -1.0f, 0.0f, 0.0f );
	v[2] = Vertex( 1.0f,  1.0f, 1.25f, 0.0f, 0.0f, -1.0f, 1.0f, 0.0f );

	v[3] = Vertex( -1.0f, -1.0f, 1.25f, 0.0f, 0.0f, -1.0f, 0.0f, 1.0f );
	v[4] = Vertex( 1.0f,  1.0f, 1.25f, 0.0f, 0.0f, -1.0f, 1.0f, 0.0f );
	v[5] = Vertex( 1.0f, -1.0f, 1.25f, 0.0f, 0.0f, -1.0f, 1.0f, 1.0f );

	_vb->Unlock();
}

Quad::~Quad()
{
	if (_vb)
		_vb->Release(); 
	_vb = 0;
}

bool Quad::draw(D3DXMATRIX* world, D3DMATERIAL9* mtrl, IDirect3DTexture9* tex)
{
	if( world )
		_device->SetTransform(D3DTS_WORLD, world);
	if( mtrl )
		_device->SetMaterial(mtrl);
	if( tex )
		_device->SetTexture(0, tex);

	_device->SetStreamSource(0, _vb, 0, sizeof(Vertex));
	_device->SetFVF(FVF_VERTEX);
	_device->DrawPrimitive( D3DPT_TRIANGLELIST,	0, 2);  

	return true;
}